/********************************************************************
********************************************************************/

#ifndef MAIN_C
#define MAIN_C

/** INCLUDES *******************************************************/
#include <p18f14k50.h>
#include <timers.h>
#include <delays.h>
#include <i2c.h>
#include "Microchip/Include/USB/usb.h"
#include "HardwareProfile.h"
#include "Microchip/Include/USB/usb_function_hid.h"
#include "app.h"
#include "I2C_RTC.h"
#include "I2C_NIXIE.h"
#include "eeprom.h"

/** CONFIGURATION **************************************************/
#pragma config CPUDIV = NOCLKDIV
#pragma config USBDIV = OFF
#pragma config FOSC   = HS
#pragma config PLLEN  = ON
#pragma config FCMEN  = OFF
#pragma config IESO   = OFF
#pragma config PWRTEN = OFF
#pragma config BOREN  = OFF
#pragma config BORV   = 30
#pragma config WDTEN  = OFF
#pragma config WDTPS  = 32768
#pragma config MCLRE  = OFF
#pragma config HFOFST = OFF
#pragma config STVREN = ON
#pragma config LVP    = OFF
#pragma config XINST  = OFF
#pragma config BBSIZ  = OFF
#pragma config CP0    = OFF
#pragma config CP1    = OFF
#pragma config CPB    = OFF
#pragma config WRT0   = OFF
#pragma config WRT1   = OFF
#pragma config WRTB   = OFF
#pragma config WRTC   = OFF
#pragma config EBTR0  = OFF
#pragma config EBTR1  = OFF
#pragma config EBTRB  = OFF                                                  // CONFIG7H


/** DEFINES ********************************************************/

/* SW1 */

/** VARIABLES ******************************************************/
#pragma udata

#if defined(__18F14K50) || defined(__18F13K50) || defined(__18LF14K50) || defined(__18LF13K50) 
    #pragma udata usbram2
#elif defined(__18F2455) || defined(__18F2550) || defined(__18F4455) || defined(__18F4550)\
    || defined(__18F2458) || defined(__18F2453) || defined(__18F4558) || defined(__18F4553)
    #pragma udata USB_VARIABLES=0x500
#elif defined(__18F4450) || defined(__18F2450)
    #pragma udata USB_VARIABLES=0x480
#else
    #pragma udata
#endif

unsigned char ReceivedDataBuffer[64];
unsigned char ToSendDataBuffer[64];

//#pragma romdata const_table=0xf00000
// offset, targetH, targetL
//const rom char my_const_array[6] = {-50, 0x0b, 0xb8,0,0x01,0x77};
/* Resume allocation of romdata into the default section */
//#pragma romdata

#pragma udata
char	c_version[]="1.0.0";

USB_HANDLE USBOutHandle = 0;
USB_HANDLE USBInHandle = 0;


//--------------------------------------------------
//ϐ
//--------------------------------------------------
// SW
#define SW_NUM			3		// SW͐
#define SW1_IDX 0
#define SW2_IDX 1
#define SW3_IDX 2
BYTE sw_now_fix[SW_NUM] = {0};
BYTE sw_now_fix_pre[SW_NUM] = {0};
BYTE sw_press_on_cnt[SW_NUM] = {0};
BYTE sw_press_off_cnt[SW_NUM] = {0};
//WORD sw_long_now_fix[SW_NUM] = {0};
//WORD sw_long_now_fix_pre[SW_NUM] = {0};
//WORD sw_long_press_on_cnt[SW_NUM] = {0};
//WORD sw_long_press_off_cnt[SW_NUM] = {0};
#define SW_ON_COUNT			50		// SW ON 50 = 50[ms] / 1.0(timer)
#define	SW_OFF_COUNT		50		// SW OFF 50 = 50[ms] / 1.0(timer)
//#define SW_LONG_ON_COUNT	3500	// SW LONG ON 3500 = 3500[ms] / 1.0(timer)
//#define	SW_LONG_OFF_COUNT	50		// SW LONG OFF 50 = 50[ms] / 1.0(timer)

// Nixie
UN_NIXIE_UNITS p_nixie_units;		// mf[^
UN_NIXIE_UNITS p_nixie_units_fix;	// mf[^
UN_NIXIE_UNIT p_nixie_unit_read_data;			// I2Cǂݍ݃f[^
BYTE i2c_read_request = 0;
BYTE i2c_read_comp = 0;

BYTE i2c_read_flag = 0;
BYTE i2c_write_flag[NIXIE_UNIT_MAX_NUM];
BYTE i2c_read_unit_no = 0;
BYTE i2c_write_unit_no = 0;

//v֌W
// Mode
#define MODE_NORMAL		0x00
#define MODE_SET_DATE_Y	0x01
#define MODE_SET_DATE_M	0x02
#define MODE_SET_DATE_D	0x04
#define MODE_SET_TIME_H	0x08
#define MODE_SET_TIME_M	0x10
#define MODE_SET_TIME_S	0x20
BYTE Mode = MODE_NORMAL;
WORD rtc_read_count = RTC_READ_COUNT_INIT;
//vݒ֌W
BYTE RTC_sec_setup = 0;
BYTE RTC_min_setup = 0;
BYTE RTC_hour_setup = 0;
BYTE RTC_day_setup = 0;
BYTE RTC_DotW_setup = 0;
BYTE RTC_month_setup = 0;
BYTE RTC_year_setup = 0;

BYTE DATETIME_First_Send_Flag = 0;
BYTE RTC_last_sec = 0xFF;
WORD RTC_blink_counter = 0;
WORD RTC_blink_counter_pre = 0;

//EEPROM
#define EEPROM_DATA_NUM			32		// EEPROM ̃f[^
//EEPROM ADDRESS
#define EEPROM_ADR_U1_1_CTRL1	0		// UNIT1-1 control1
#define EEPROM_ADR_U1_2_CTRL1	6		// UNIT1-2 control1
#define EEPROM_ADR_U1_3_CTRL1	12		// UNIT1-3 control1
#define EEPROM_ADR_U1_4_CTRL1	18		// UNIT1-4 control1
#define EEPROM_ADR_U1_1_CTRL2	24		// UNIT1-1 control2
#define EEPROM_ADR_U1_2_CTRL2	30		// UNIT1-2 control2
#define EEPROM_ADR_U1_3_CTRL2	36		// UNIT1-3 control2
#define EEPROM_ADR_U1_4_CTRL2	42		// UNIT1-4 control2
#define EEPROM_ADR_U2_1_CTRL1	48
#define EEPROM_ADR_U2_2_CTRL1	54
#define EEPROM_ADR_U2_3_CTRL1	60
#define EEPROM_ADR_U2_4_CTRL1	66
#define EEPROM_ADR_U2_1_CTRL2	72
#define EEPROM_ADR_U2_2_CTRL2	78
#define EEPROM_ADR_U2_3_CTRL2	84
#define EEPROM_ADR_U2_4_CTRL2	90
#define EEPROM_ADR_U3_1_CTRL1	96
#define EEPROM_ADR_U3_2_CTRL1	102
#define EEPROM_ADR_U3_3_CTRL1	108
#define EEPROM_ADR_U3_4_CTRL1	114
#define EEPROM_ADR_U3_1_CTRL2	120
#define EEPROM_ADR_U3_2_CTRL2	126
#define EEPROM_ADR_U3_3_CTRL2	132
#define EEPROM_ADR_U3_4_CTRL2	138
#define EEPROM_ADR_U4_1_CTRL1	144
#define EEPROM_ADR_U4_2_CTRL1	150
#define EEPROM_ADR_U4_3_CTRL1	156
#define EEPROM_ADR_U4_4_CTRL1	162
#define EEPROM_ADR_U4_1_CTRL2	168
#define EEPROM_ADR_U4_2_CTRL2	174
#define EEPROM_ADR_U4_3_CTRL2	180
#define EEPROM_ADR_U4_4_CTRL2	186
// EEPROMAhXi[z
rom BYTE eeprom_data_adr[EEPROM_DATA_NUM] =
{
	EEPROM_ADR_U1_1_CTRL1, EEPROM_ADR_U1_2_CTRL1, EEPROM_ADR_U1_3_CTRL1, EEPROM_ADR_U1_4_CTRL1,
	EEPROM_ADR_U1_1_CTRL2, EEPROM_ADR_U1_2_CTRL2, EEPROM_ADR_U1_3_CTRL2, EEPROM_ADR_U1_4_CTRL2,
	EEPROM_ADR_U2_1_CTRL1, EEPROM_ADR_U2_2_CTRL1, EEPROM_ADR_U2_3_CTRL1, EEPROM_ADR_U2_4_CTRL1,
	EEPROM_ADR_U2_1_CTRL2, EEPROM_ADR_U2_2_CTRL2, EEPROM_ADR_U2_3_CTRL2, EEPROM_ADR_U2_4_CTRL2,
	EEPROM_ADR_U3_1_CTRL1, EEPROM_ADR_U3_2_CTRL1, EEPROM_ADR_U3_3_CTRL1, EEPROM_ADR_U3_4_CTRL1,
	EEPROM_ADR_U3_1_CTRL2, EEPROM_ADR_U3_2_CTRL2, EEPROM_ADR_U3_3_CTRL2, EEPROM_ADR_U3_4_CTRL2,
	EEPROM_ADR_U4_1_CTRL1, EEPROM_ADR_U4_2_CTRL1, EEPROM_ADR_U4_3_CTRL1, EEPROM_ADR_U4_4_CTRL1,
	EEPROM_ADR_U4_1_CTRL2, EEPROM_ADR_U4_2_CTRL2, EEPROM_ADR_U4_3_CTRL2, EEPROM_ADR_U4_4_CTRL2
};
// EEPROMftHgli[z
rom BYTE eeprom_default_data[EEPROM_DATA_NUM] =
{
	0x00, 0x00, 0x00, 0x01,
	0x01, 0x02, 0x03, 0x04,
	0x00, 0x01, 0x00, 0x01,
	0x05, 0x06, 0x07, 0x08,
	0x00, 0x01, 0x00, 0x01,
	0x09, 0x0A, 0x0B, 0x0C,
	0x00, 0x00, 0x00, 0x00,
	0x0D, 0x0E, 0x00, 0x00
};	

#pragma udata
	
// fobO
unsigned char debug_array[16] = {0};

#pragma udata

/** PRIVATE PROTOTYPES *********************************************/
static void InitializeSystem(void);
void ProcessIO(void);
void UserInit(void);
void YourHighPriorityISRCode();
void YourLowPriorityISRCode();
void USBCBSendResume(void);
//--------------------------------------------------
// function
//--------------------------------------------------
void sw_input_check( void );
BYTE eeprom_save_check_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data);
void eeprom_save_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data);
void eeprom_read_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data);
void set_number(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data);
void set_fix_number(void);
void Set_Data_Datetime(BYTE p_unit_no);

/** VECTOR REMAPPING ***********************************************/
#if defined(__18CXX)
	//On PIC18 devices, addresses 0x00, 0x08, and 0x18 are used for
	//the reset, high priority interrupt, and low priority interrupt
	//vectors.  However, the current Microchip USB bootloader 
	//examples are intended to occupy addresses 0x00-0x7FF or
	//0x00-0xFFF depending on which bootloader is used.  Therefore,
	//the bootloader code remaps these vectors to new locations
	//as indicated below.  This remapping is only necessary if you
	//wish to program the hex file generated from this project with
	//the USB bootloader.  If no bootloader is used, edit the
	//usb_config.h file and comment out the following defines:
	//#define PROGRAMMABLE_WITH_USB_HID_BOOTLOADER
	//#define PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x1000
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
	#elif defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x800
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
	#else	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x00
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
	#endif
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void)
	{
	    _asm goto _startup _endasm
	}
	#endif
	#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void)
	{
	     _asm goto YourHighPriorityISRCode _endasm
	}
	#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void)
	{
	     _asm goto YourLowPriorityISRCode _endasm
	}
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	//Note: If this project is built while one of the bootloaders has
	//been defined, but then the output hex file is not programmed with
	//the bootloader, addresses 0x08 and 0x18 would end up programmed with 0xFFFF.
	//As a result, if an actual interrupt was enabled and occured, the PC would jump
	//to 0x08 (or 0x18) and would begin executing "0xFFFF" (unprogrammed space).  This
	//executes as nop instructions, but the PC would eventually reach the REMAPPED_RESET_VECTOR_ADDRESS
	//(0x1000 or 0x800, depending upon bootloader), and would execute the "goto _startup".  This
	//would effective reset the application.
	
	//To fix this situation, we should always deliberately place a 
	//"goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS" at address 0x08, and a
	//"goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS" at address 0x18.  When the output
	//hex file of this project is programmed with the bootloader, these sections do not
	//get bootloaded (as they overlap the bootloader space).  If the output hex file is not
	//programmed using the bootloader, then the below goto instructions do get programmed,
	//and the hex file still works like normal.  The below section is only required to fix this
	//scenario.
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void)
	{
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void)
	{
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#endif	//end of "#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER)"

	#pragma code
	
	
	//These are your actual interrupt handling routines.
	#pragma interrupt YourHighPriorityISRCode
	void YourHighPriorityISRCode()
	{
		//Check which interrupt flag caused the interrupt.
		//Service the interrupt
		//Clear the interrupt flag
		//Etc.
        #if defined(USB_INTERRUPT)
	        USBDeviceTasks();
        #endif

	}	//This return will be a "retfie fast", since this is in a #pragma interrupt section 
	#pragma interruptlow YourLowPriorityISRCode
	void YourLowPriorityISRCode()
	{
	    if(INTCONbits.TMR0IF == 1)
		{	// Timer 0
			INTCONbits.TMR0IF = 0;
			WriteTimer0(WRITE_TIMER0_COUNT);

			if(RTC_blink_counter > 0)
			{
				RTC_blink_counter--;
			}


			debug_array[0]++;	// DEBUG
		}
		if(PIR1bits.TMR1IF == 1)
		{	// Timer 1
			PIR1bits.TMR1IF = 0;
			WriteTimer1(WRITE_TIMER1_COUNT);
			
			// RTC Read Interval
			if(rtc_read_count > 0)
			{
				rtc_read_count--;
			}

			sw_input_check();
			
			debug_array[1]++;	// DEBUG
		}
	}	//This return will be a "retfie", since this is in a #pragma interruptlow section 
#endif




/** DECLARATIONS ***************************************************/
#pragma code

/********************************************************************
 * Function:        void main(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Main program entry point.
 *
 * Note:            None
 *******************************************************************/
#if defined(__18CXX)
void main(void)
#else
int main(void)
#endif
{   
    InitializeSystem();

    #if defined(USB_INTERRUPT)
        USBDeviceAttach();
    #endif

    while(1)
    {
        #if defined(USB_POLLING)
		// Check bus status and service USB interrupts.
        USBDeviceTasks(); // Interrupt or polling method.  If using polling, must call
        #endif

		// Application-specific tasks.
		// Application related code may be added here, or in the ProcessIO() function.
        ProcessIO();        
    }//end while
}//end main


/********************************************************************
 * Function:        static void InitializeSystem(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        InitializeSystem is a centralize initialization
 *                  routine. All required USB initialization routines
 *                  are called from here.
 *
 *                  User application initialization routine should
 *                  also be called from here.                  
 *
 * Note:            None
 *******************************************************************/
static void InitializeSystem(void)
{
    #if defined(USE_USB_BUS_SENSE_IO)
    tris_usb_bus_sense = INPUT_PIN; // See HardwareProfile.h
    #endif
    #if defined(USE_SELF_POWER_SENSE_IO)
    tris_self_power = INPUT_PIN;	// See HardwareProfile.h
    #endif

    UserInit();
    
    USBDeviceInit();	//usb_device.c.  Initializes USB module SFRs and firmware
    					//variables to known states.
}//end InitializeSystem



/******************************************************************************
 * Function:        void UserInit(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This routine should take care of all of the demo code
 *                  initialization that is required.
 *
 * Note:            
 *
 *****************************************************************************/
void UserInit(void)
{
	BYTE fi, fj;
	int buff_size;

//	|[g̐ݒ
	LATA = 0;
	LATB = 0;
	LATC = 0;
	//PORT A ******************************************************************************************
	//RA3͓ b5:RA5 b4:RA4 b3:RA3 b1:RA1 b0:RA0
	//RA0 = 
	//RA1 = 
	//RA3 = 
	//RA4 =
	//RA5 =
	TRISA = 0x00;
	//PORT B ******************************************************************************************
	//RB4/5/6 b7:RB7 b6:RB6 b5:RB5 b4:RB4
	//RB4 = SDA
	//RB5 = SW3
	//RB6 = SCK
	//RB7 = 
	TRISB = 0x70;
	//PORT C  ******************************************************************************************
	//RC1/2̂ݓ́Aׂ͂ďo b7:RC7 b6:RC6 b5:RC5 b4:RC4 b3:RC3 b2:RC2 b1:RC1 bit0:RC0
	//RC0 = 
	//RC1 = SW1
	//RC2 = SW2
	//RC3 = 
	//RC4 = 
	//RC5 = 
	//RC6 = 
	//RC7 = 
	TRISC = 0x06;

	INTCON2bits.RABPU = 1;		//vAbv𖳌ɂ


//@eϐ̏
	for(fi = 0; fi < NIXIE_UNIT_MAX_NUM; fi++)
	{
		for(fj = 0; fj < NIXIE_TUBE_NUM; fj++)
		{
			p_nixie_units.nixie_unit[fi].nixie_data.disp_num[fj] = 0xFF;
			p_nixie_units.nixie_unit[fi].nixie_data.disp_ctrl_1[fj] = 0;
			p_nixie_units.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] = 0;
			p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_num[fj] = 0xFF;
			p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_1[fj] = 0;
			p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] = 0;
		}
	}
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		p_nixie_unit_read_data.nixie_data.disp_num[fi] = 0xFF;
		p_nixie_unit_read_data.nixie_data.disp_ctrl_1[fi] = 0;
		p_nixie_unit_read_data.nixie_data.disp_ctrl_2[fi] = 0;
	}

	// NAP񑗐M
	for(fi = 0; fi <NIXIE_UNIT_MAX_NUM; fi++)
	{
		i2c_write_flag[fi] = 1;
	}	
	

//	d͊Ǘ[h̐ݒ
//	PRI_IDLE
	OSCCON = 0;
//	OSCCONbits.IDLEN = 1;

// AiOݒ
	ANSEL = 0x00;	//SăfW^
	ANSELH = 0x00; 

//	^C}
//	^C}0̏
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_1);
	WriteTimer0(WRITE_TIMER0_COUNT);
//	^C}1̏
	OpenTimer1(TIMER_INT_ON & T1_16BIT_RW & T1_SOURCE_INT & T1_OSC1EN_OFF & T1_SYNC_EXT_OFF & T1_PS_1_8);
	WriteTimer1(WRITE_TIMER1_COUNT);
	
//	荞݊Jn
	RCONbits.IPEN = 1;	//荞ݗDt
	INTCON2bits.TMR0IP = 0;	//^C}0ʃx荞݂ɐݒ
	INTCONbits.TMR0IE = 1;	//^C}0荞݋
	IPR1bits.TMR1IP = 0;	//^C}1ʃx荞݂ɐݒ
	PIE1bits.TMR1IE = 1;	//^C}1荞݋

	INTCONbits.GIEL = 1;	//ʃx荞݂̋
//	INTCONbits.GIEH = 1;	//ʃx荞݂̋
	INTCONbits.GIE = 1;

	// I2C 
	OpenI2C( MASTER, SLEW_OFF );
	// 48MHz / ( 4 * ( X + 1 ) = 100,000bps(100kbps)
	// X = 48,000,000 / ( 4 * 100,000 ) - 1 = 119
//	SSPADD = 119;
	// 48MHz / ( 4 * ( X + 1 ) = 400,000bps(400kbps)
	// X = 48,000,000 / ( 4 * 400,000 ) - 1 = 29
	SSPADD = 29;

	// RTC 
	I2C_RTC_init();

	// EEPROM ǂݍ
	for(fi = 0; fi < NIXIE_UNIT_MAX_NUM; fi++)
	{
		eeprom_read_nixie_data(fi+1, (UN_NIXIE_UNIT *)&p_nixie_units.nixie_unit[fi]);
	}

    //initialize the variable holding the handle for the last
    // transmission
    USBOutHandle = 0;
    USBInHandle = 0;

}//end UserInit
	
/********************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user
 *                  routines. It is a mixture of both USB and
 *                  non-USB tasks.
 *
 * Note:            None
 *******************************************************************/
void ProcessIO(void)
{
	BYTE fi, fj;
	char tmp;
	BYTE b_tmp;
	BYTE debug_tmp[4];

	// m\f[^Zbg
	set_fix_number();

// RTCǂݍ
	if(rtc_read_count == 0 && Mode == MODE_NORMAL)
	{
		rtc_read_count = RTC_READ_COUNT_INIT;

		I2C_RTC_read();
	}

// RTCl\pobt@ɃZbg
	Set_Data_Datetime(i2c_write_unit_no);

	// SjbgɃf[^𑗐M
	for(fi = 0; fi < NIXIE_UNIT_MAX_NUM; fi++)
	{
		// ݁H
		if(i2c_write_flag[fi] > 0)
		{
			i2c_write_flag[fi]--;
			
			// _jbg֕\f[^M
			I2C_NIXIE_write(fi+1, I2C_NIXIE_NUMBER_TOP_ADR, (BYTE*)&p_nixie_units_fix.nixie_unit[fi], (BYTE)(sizeof(UN_NIXIE_UNIT)));

			//DEBUG
			debug_array[2]++;	// DEBUG
		}
	}


	// i2c Nixie read
	if(i2c_read_request != 0)
	{
		i2c_read_request = 0;

		if(1 <= i2c_read_unit_no && i2c_read_unit_no <= NIXIE_UNIT_MAX_NUM)
		{
			if(I2C_NIXIE_read(i2c_read_unit_no, I2C_NIXIE_NUMBER_TOP_ADR, (BYTE *)&p_nixie_unit_read_data, (BYTE)(sizeof(UN_NIXIE_UNIT))) == 0)
			{
				i2c_read_comp = 1;
			}
			else
			{
				i2c_read_comp = 0;
			}
		}
	}
	


//***************************************
//	USBʐM
//***************************************
    // User Application USB tasks
    if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;

    if(!HIDRxHandleBusy(USBOutHandle))				//Check if data was received from the host.
    {   
        switch(ReceivedDataBuffer[0])				//Look at the data the host sent, to see what kind of application specific command it sent.
        {
            case 0x56: // V=0x56 Get Firmware version
                ToSendDataBuffer[0] = 0x56;				//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.
				tmp = strlen(c_version);
				if( 0 < tmp && tmp <= (64-2) )
				{
					for( fi = 0; fi < tmp; fi++ )
					{
						ToSendDataBuffer[fi+1] = c_version[fi];
					}
					// ŌNULLݒ
					ToSendDataBuffer[fi+1] = 0x00;
				}
				else
				{
					//o[Wُ
					ToSendDataBuffer[1] = 0x00;
				}	
		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x21:  // Time Set [0]=second, [1]=minute, [2]=hour, [3]=Weekdays(0=...6=y), [4]=day, [5]=month, [6]=year
				ToSendDataBuffer[0] = 0x21;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.

				b_tmp = (ReceivedDataBuffer[1] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[1] % 10);
				RTC_set_sec = b_tmp;
				b_tmp = (ReceivedDataBuffer[2] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[2] % 10);
				RTC_set_min = b_tmp;
				b_tmp = (ReceivedDataBuffer[3] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[3] % 10);
				RTC_set_hour = b_tmp;
				RTC_set_DotW = ReceivedDataBuffer[4];
				b_tmp = (ReceivedDataBuffer[5] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[5] % 10);
				RTC_set_day = b_tmp;
				b_tmp = (ReceivedDataBuffer[6] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[6] % 10);
				RTC_set_month = b_tmp;
				b_tmp = (ReceivedDataBuffer[7] / 10);
				b_tmp = (b_tmp << 4) | (ReceivedDataBuffer[7] % 10);
				RTC_set_year = b_tmp;
				I2C_RTC_write();

	           	// OKAT
	           	ToSendDataBuffer[1] = 0x00;

		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x22:  // Number Set [0]=Nixie Unit No., [1]=number1, [2]=control1, [3]=number2, [4]=control2, ... , [7]=number4, [8]=control4
				ToSendDataBuffer[0] = 0x22;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.

				// EEPROMۑ`FbN
				if(eeprom_save_check_nixie_data(ReceivedDataBuffer[1], (UN_NIXIE_UNIT*)&ReceivedDataBuffer[2]) == 1)
				{	// EEPROMۑ
					eeprom_save_nixie_data(ReceivedDataBuffer[1], (UN_NIXIE_UNIT*)&ReceivedDataBuffer[2]);
				}

				set_number(ReceivedDataBuffer[1], (UN_NIXIE_UNIT*)&ReceivedDataBuffer[2]);

				i2c_write_unit_no = ReceivedDataBuffer[1];

				if(1 <= i2c_write_unit_no && i2c_write_unit_no <= NIXIE_UNIT_MAX_NUM)
				{
					i2c_write_flag[i2c_write_unit_no-1] = 2;
				}	
				
	           	// OKAT
	           	ToSendDataBuffer[1] = 0x00;

		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x23:  // Number Set fast [0]=unit1 number1, [1]=unit1 control1, [2]=unit1 number2, [3]=unit 1control2, ... , [30]=unit4 number4, [31]=unit4 control4
				ToSendDataBuffer[0] = 0x23;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.
				for( fi = 0; fi < NIXIE_UNIT_MAX_NUM; fi++ )
				{
					// EEPROMۑ`FbN
					if(eeprom_save_check_nixie_data((BYTE)(fi+1), (UN_NIXIE_UNIT*)&ReceivedDataBuffer[1+sizeof(UN_NIXIE_UNIT)*fi]) == 1)
					{	// EEPROMۑ
						eeprom_save_nixie_data((BYTE)(fi+1), (UN_NIXIE_UNIT*)&ReceivedDataBuffer[1+sizeof(UN_NIXIE_UNIT)*fi]);
					}
				
					set_number((BYTE)(fi+1), (UN_NIXIE_UNIT*)&ReceivedDataBuffer[1+sizeof(UN_NIXIE_UNIT)*fi]);
					i2c_write_flag[fi] = 2;
				}
				
				i2c_write_unit_no = 1;

	           	// OKAT
	           	ToSendDataBuffer[1] = 0x00;

		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x24:  // I2C Read Number Request
				ToSendDataBuffer[0] = 0x24;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.

				// Read Number Request Set
				i2c_read_unit_no = ReceivedDataBuffer[1];
				i2c_read_request = 1;
				i2c_read_comp = 0;

	           	// OKAT
	           	ToSendDataBuffer[1] = 0x00;

		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x25:  // I2C Read Number Send
				ToSendDataBuffer[0] = 0x25;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.

	           	// Read Status Set
	           	ToSendDataBuffer[1] = i2c_read_comp;	// 0=ǂݍ 1=ǂݍ݊

				if(i2c_read_comp != 0)
				{	// ǂݍ݊
					for(fi = 0; fi < sizeof(UN_NIXIE_UNIT); fi++)
					{
						ToSendDataBuffer[2+fi] = p_nixie_unit_read_data.byte[fi];
					}
				}
				else
				{	// ǂݍݖ
					for(fi = 0; fi < sizeof(UN_NIXIE_UNIT); fi++)
					{
						ToSendDataBuffer[2+fi] = 0x00;
					}
				}

		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x26:  // Blink Interval Set
				ToSendDataBuffer[0] = 0x26;	//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.

				if(1 <= ReceivedDataBuffer[1] && ReceivedDataBuffer[1] <= NIXIE_UNIT_MAX_NUM)
				{
					I2C_NIXIE_write(ReceivedDataBuffer[1], I2C_NIXIE_BLINK_ON_TIME_L_ADR, (BYTE*)&ReceivedDataBuffer[2], 4);

		           	// OKAT
		           	ToSendDataBuffer[1] = 0x00;
				}
				else
				{
		           	// NGAT
		           	ToSendDataBuffer[1] = 0x01;
				}
	
		        if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
// DEBUG##########################################################################################
            case 0x40:
                ToSendDataBuffer[0] = 0x40;				//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.
#if 1
				ToSendDataBuffer[1] = debug_array[0];
				ToSendDataBuffer[2] = debug_array[1];
				ToSendDataBuffer[3] = debug_array[2];
				ToSendDataBuffer[4] = debug_array[3];
				ToSendDataBuffer[5] = debug_array[4];
				ToSendDataBuffer[6] = debug_array[5];
				ToSendDataBuffer[7] = debug_array[6];
				ToSendDataBuffer[8] = debug_array[7];
				ToSendDataBuffer[9] = debug_array[8];
				ToSendDataBuffer[10] = debug_array[9];
				ToSendDataBuffer[11] = debug_array[10];
				ToSendDataBuffer[12] = debug_array[11];
				ToSendDataBuffer[13] = debug_array[12];
				ToSendDataBuffer[14] = debug_array[13];
				ToSendDataBuffer[15] = debug_array[14];
				ToSendDataBuffer[16] = debug_array[15];
#endif

                if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
            case 0x41:
                ToSendDataBuffer[0] = 0x41;				//Echo back to the host PC the command we are fulfilling in the first byte.  In this case, the Get Pushbutton State command.
#if 1
				ToSendDataBuffer[1] = RTC_year;
				ToSendDataBuffer[2] = RTC_month;
				ToSendDataBuffer[3] = RTC_day;
				ToSendDataBuffer[4] = RTC_DotW;
				ToSendDataBuffer[5] = RTC_hour;
				ToSendDataBuffer[6] = RTC_min;
				ToSendDataBuffer[7] = RTC_sec;
				ToSendDataBuffer[8] = 0;
				ToSendDataBuffer[9] = 0;
				ToSendDataBuffer[10] = 0;
				ToSendDataBuffer[11] = 0;
				ToSendDataBuffer[12] = i2c_write_flag[0];
				ToSendDataBuffer[13] = i2c_write_flag[1];
				ToSendDataBuffer[14] = i2c_write_flag[2];
				ToSendDataBuffer[15] = i2c_write_flag[3];
				ToSendDataBuffer[16] = p_nixie_units.byte[0];
#endif

                if(!HIDTxHandleBusy(USBInHandle))
                {
                    USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],64);
                }
                break;
//DEBUG##########################################################################################
        }
        //Re-arm the OUT endpoint for the next packet
        USBOutHandle = HIDRxPacket(HID_EP,(BYTE*)&ReceivedDataBuffer,64);
    }
}//end ProcessIO

void sw_input_check( void )
{
	BYTE fi;
	BYTE sw_now[SW_NUM];

	sw_now[SW1_IDX] 	= SW_1;
	sw_now[SW2_IDX] 	= SW_2;
	sw_now[SW3_IDX] 	= SW_3;

	for( fi = 0; fi < SW_NUM; fi++ )
	{
		if(sw_now[fi] == R_ON)
		{
			// ON 
			sw_press_on_cnt[fi]++;
			if( sw_press_on_cnt[fi] >= SW_ON_COUNT)
			{
				sw_press_off_cnt[fi] = 0;
				sw_now_fix[fi] = N_ON;
				sw_press_on_cnt[fi] = SW_ON_COUNT;
			}
			// LONG ON 
//			sw_long_press_on_cnt[fi]++;
//			if( sw_long_press_on_cnt[fi] >= SW_LONG_ON_COUNT)
//			{
//				sw_long_press_off_cnt[fi] = 0;
//				sw_long_now_fix[fi] = N_ON;
//				sw_long_press_on_cnt[fi] = SW_LONG_ON_COUNT;
//			}
		}
		else
		{
			// OFF 
			sw_press_off_cnt[fi]++;
			if(sw_press_off_cnt[fi] >= SW_OFF_COUNT)
			{
				sw_press_on_cnt[fi] = 0;
				sw_now_fix[fi] = N_OFF;
				sw_press_off_cnt[fi] = SW_OFF_COUNT;
			}
			// LONG OFF 
//			sw_long_press_off_cnt[fi]++;
//			if(sw_long_press_off_cnt[fi] >= SW_LONG_OFF_COUNT)
//			{
//				sw_long_press_on_cnt[fi] = 0;
//				sw_long_now_fix[fi] = N_OFF;
//				sw_long_press_off_cnt[fi] = SW_LONG_OFF_COUNT;
//			}
		}

		// SW OFF -> ON
		if(sw_now_fix_pre[fi] == N_OFF && sw_now_fix[fi] == N_ON)
		{
			switch (fi)
			{
				case SW1_IDX:
					// SW1 OFF -> ON
					break;
				case SW2_IDX:
					// SW2 OFF -> ON
					break;
				case SW3_IDX:
					// SW3 OFF -> ON
					break;
			}	
		}	

		
		// lۑ
		sw_now_fix_pre[fi] = sw_now_fix[fi];
//		sw_long_now_fix_pre[fi] = sw_long_now_fix[fi];	
	}	
}

BYTE eeprom_save_check_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data)
{
	BYTE ret = 0;
	BYTE fi;
	
	// Parameter check
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{
		return ret;
	}
	
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		if((p_set_data->nixie_data.disp_ctrl_2[fi] & NIXIE_CTRL_DATE_ALL) != 0)
		{	// v\ݒ肠
			
			// Control 1 Ɓ@2̕ω`FbN
			if(p_nixie_units.nixie_unit[p_unit_no-1].nixie_data.disp_ctrl_1[fi] != p_set_data->nixie_data.disp_ctrl_1[fi])
			{
				// ω
				ret = 1;
				break;
			}
			if(p_nixie_units.nixie_unit[p_unit_no-1].nixie_data.disp_ctrl_2[fi] != p_set_data->nixie_data.disp_ctrl_2[fi])
			{
				// ω
				ret = 1;
				break;
			}		
		}
	}
	return ret;	
}
void eeprom_save_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_save_data)
{
	BYTE fi;
	
	// Parameter check
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{
		return;
	}

	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		WriteEEPROM_Agree(eeprom_data_adr[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+fi], p_save_data->nixie_data.disp_ctrl_1[fi], EEPROM_SAVE_NUM);
		WriteEEPROM_Agree(eeprom_data_adr[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+NIXIE_TUBE_NUM+fi], p_save_data->nixie_data.disp_ctrl_2[fi], EEPROM_SAVE_NUM);
	}
}
void eeprom_read_nixie_data(BYTE p_unit_no, UN_NIXIE_UNIT *p_read_data)
{
	BYTE fi;
	BYTE ctrl1_read, ctrl2_read;
	
	// Parameter check
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{
		return;
	}
	
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		if(ReadEEPROM_Agree(eeprom_data_adr[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+fi], EEPROM_SAVE_NUM, EEPROM_SAME_COUNT, &ctrl1_read) != 0)
		{
			ctrl1_read = 0;
		}
		if(ReadEEPROM_Agree(eeprom_data_adr[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+NIXIE_TUBE_NUM+fi], EEPROM_SAVE_NUM, EEPROM_SAME_COUNT, &ctrl2_read) != 0)
		{
			ctrl2_read = 0;
		}
		
		if(ctrl1_read != 0xFF || ctrl2_read != 0xFF)
		{	// ctrl1  ctrl2 0xFFłȂꍇ͓ǂݍ񂾒lZbg
			p_read_data->nixie_data.disp_ctrl_1[fi] = ctrl1_read;
			p_read_data->nixie_data.disp_ctrl_2[fi] = ctrl2_read;
		}
		else
		{
			p_read_data->nixie_data.disp_ctrl_1[fi] = eeprom_default_data[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+fi];
			p_read_data->nixie_data.disp_ctrl_2[fi] = eeprom_default_data[(p_unit_no-1)*(NIXIE_TUBE_NUM+NIXIE_TUBE_NUM)+NIXIE_TUBE_NUM+fi];
		}
	}
}

void set_number(BYTE p_unit_no, UN_NIXIE_UNIT *p_set_data)
{
	BYTE fi;
	
	// Parameter check
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{
		return;
	}
	
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		p_nixie_units.nixie_unit[p_unit_no-1].nixie_data.disp_num[fi] = p_set_data->nixie_data.disp_num[fi];
		p_nixie_units.nixie_unit[p_unit_no-1].nixie_data.disp_ctrl_1[fi] = p_set_data->nixie_data.disp_ctrl_1[fi];
		p_nixie_units.nixie_unit[p_unit_no-1].nixie_data.disp_ctrl_2[fi] = p_set_data->nixie_data.disp_ctrl_2[fi];
	}	
}

void set_fix_number(void)
{
	BYTE fi, buff_size;

	buff_size = sizeof(UN_NIXIE_UNITS);
	for(fi = 0; fi < buff_size; fi++)
	{
		p_nixie_units_fix.byte[fi] = p_nixie_units.byte[fi];
	}	
}
void Set_Data_Datetime(BYTE p_unit_no)
{
	BYTE fi, fj;
	BYTE set_num;
	BYTE mask;
	BYTE date_setting_count = 0;
	WORD tmp_RTC_blink_counter = RTC_blink_counter;

	for(fi = 0; fi < NIXIE_UNIT_MAX_NUM; fi++)
	{
		for(fj = 0; fj < NIXIE_TUBE_NUM; fj++)
		{
			if((p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_DATE_ALL) != 0)
			{	// \w肠
				date_setting_count++;
				
				set_num = p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_num[fj];
				switch((p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_DATE_ALL))
				{
					case NIXIE_CTRL_YEAR1000:
						set_num = 0x02;	// 20xxŒ
						break;
					case NIXIE_CTRL_YEAR100:
						set_num = 0x00;	// 20xxŒ
						break;
					case NIXIE_CTRL_YEAR10:
						set_num = (BYTE)((RTC_year >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_YEAR1:
						set_num = (BYTE)(RTC_year & 0x0F);
						break;
					case NIXIE_CTRL_MONTH10:
						set_num = (BYTE)((RTC_month >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_MONTH1:
						set_num = (BYTE)(RTC_month & 0x0F);
						break;
					case NIXIE_CTRL_DAY10:
						set_num = (BYTE)((RTC_day >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_DAY1:
						set_num = (BYTE)(RTC_day & 0x0F);
						break;
					case NIXIE_CTRL_HOUR10:
						set_num = (BYTE)((RTC_hour >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_HOUR1:
						set_num = (BYTE)(RTC_hour & 0x0F);
						break;
					case NIXIE_CTRL_MIN10:
						set_num = (BYTE)((RTC_min >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_MIN1:
						set_num = (BYTE)(RTC_min & 0x0F);
						break;
					case NIXIE_CTRL_SEC10:
						set_num = (BYTE)((RTC_sec >> 4) & 0x0F);
						break;
					case NIXIE_CTRL_SEC1:
						set_num = (BYTE)(RTC_sec & 0x0F);
						break;
					default:
						break;
				}

				// \ύX@
				// ܂́@\
				// ܂́@v_Ŏw莞					
				if(set_num != p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_num[fj]
					|| DATETIME_First_Send_Flag == 0
					|| (p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_DOT) != 0
					|| (p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_NUM) != 0)
				{	// bύX^C~O@܂́@
					p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_num[fj] = set_num;

					// bς瑗M
					if(RTC_last_sec != RTC_sec)
					{
						i2c_write_flag[fi] = 2;
						
						// _ŃJE^[Zbg
						if((p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_DOT) != 0
							|| (p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_NUM) != 0)
						{
							RTC_blink_counter = NIXIE_RTC_BLINK_TIME;
							tmp_RTC_blink_counter = RTC_blink_counter;
						}
					}


					if((p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_DOT) != 0)
					{	// _Ł@hbg
						if(tmp_RTC_blink_counter > 0)
						{	//_
							mask = NIXIE_CTRL_DOT_RB | NIXIE_CTRL_DOT_LB;
							mask = ~mask;
							p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_1[fj] &= mask;	//_ŃtONA
						}
						else if(tmp_RTC_blink_counter == 0)
						{	//
							mask = NIXIE_CTRL_DOT_RB | NIXIE_CTRL_DOT_LB | NIXIE_CTRL_DOT_ALL;
							mask = ~mask;
							p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_1[fj] &= mask;
							// _̃^C~OőM
							if(RTC_blink_counter_pre > 0 && tmp_RTC_blink_counter == 0)
							{
								i2c_write_flag[fi] = 2;
							}
						}
					}
					if((p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_2[fj] & NIXIE_CTRL_TIME_BLINK_NUM) != 0)
					{	// _Ł@
						if(tmp_RTC_blink_counter > 0)
						{	//_
							mask = NIXIE_CTRL_NUM_BLINK;
							mask = ~mask;
							p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_ctrl_1[fj] &= mask;	//_ŃtONA
						}
						else if(tmp_RTC_blink_counter == 0)
						{	//
							p_nixie_units_fix.nixie_unit[fi].nixie_data.disp_num[fj] = 0xFF;
							// _̃^C~OőM
							if(RTC_blink_counter_pre > 0 && tmp_RTC_blink_counter == 0)
							{
								i2c_write_flag[fi] = 2;
							}
						}
					}
				}
			}
		}
	}
	
	RTC_last_sec = RTC_sec;
	
	if(date_setting_count == 0)
	{	// DatݒȂ
		DATETIME_First_Send_Flag = 0;
	}
	else
	{
		DATETIME_First_Send_Flag = 1;
	}
	
	RTC_blink_counter_pre = tmp_RTC_blink_counter;
}

// ******************************************************************************************************
// ************** USB Callback Functions ****************************************************************
// ******************************************************************************************************
// The USB firmware stack will call the callback functions USBCBxxx() in response to certain USB related
// events.  For example, if the host PC is powering down, it will stop sending out Start of Frame (SOF)
// packets to your device.  In response to this, all USB devices are supposed to decrease their power
// consumption from the USB Vbus to <2.5mA each.  The USB module detects this condition (which according
// to the USB specifications is 3+ms of no bus activity/SOF packets) and then calls the USBCBSuspend()
// function.  You should modify these callback functions to take appropriate actions for each of these
// conditions.  For example, in the USBCBSuspend(), you may wish to add code that will decrease power
// consumption from Vbus to <2.5mA (such as by clock switching, turning off LEDs, putting the
// microcontroller to sleep, etc.).  Then, in the USBCBWakeFromSuspend() function, you may then wish to
// add code that undoes the power saving things done in the USBCBSuspend() function.

// The USBCBSendResume() function is special, in that the USB stack will not automatically call this
// function.  This function is meant to be called from the application firmware instead.  See the
// additional comments near the function.

/******************************************************************************
 * Function:        void USBCBSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Call back that is invoked when a USB suspend is detected
 *
 * Note:            None
 *****************************************************************************/
void USBCBSuspend(void)
{
	//Example power saving code.  Insert appropriate code here for the desired
	//application behavior.  If the microcontroller will be put to sleep, a
	//process similar to that shown below may be used:
	
	//ConfigureIOPinsForLowPower();
	//SaveStateOfAllInterruptEnableBits();
	//DisableAllInterruptEnableBits();
	//EnableOnlyTheInterruptsWhichWillBeUsedToWakeTheMicro();	//should enable at least USBActivityIF as a wake source
	//Sleep();
	//RestoreStateOfAllPreviouslySavedInterruptEnableBits();	//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.
	//RestoreIOPinsToNormal();									//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.

	//IMPORTANT NOTE: Do not clear the USBActivityIF (ACTVIF) bit here.  This bit is 
	//cleared inside the usb_device.c file.  Clearing USBActivityIF here will cause 
	//things to not work as intended.	
	

    #if defined(__C30__)
        //This function requires that the _IPL level be something other than 0.
        //  We can set it here to something other than 
        _IPL = 1;
        USBSleepOnSuspend();
    #endif
}


/******************************************************************************
 * Function:        void _USB1Interrupt(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called when the USB interrupt bit is set
 *					In this example the interrupt is only used when the device
 *					goes to sleep when it receives a USB suspend command
 *
 * Note:            None
 *****************************************************************************/
#if 0
void __attribute__ ((interrupt)) _USB1Interrupt(void)
{
    #if !defined(self_powered)
        if(U1OTGIRbits.ACTVIF)
        {
            IEC5bits.USB1IE = 0;
            U1OTGIEbits.ACTVIE = 0;
            IFS5bits.USB1IF = 0;
        
            //USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);
            USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
            //USBSuspendControl = 0;
        }
    #endif
}
#endif

/******************************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The host may put USB peripheral devices in low power
 *					suspend mode (by "sending" 3+ms of idle).  Once in suspend
 *					mode, the host may wake the device back up by sending non-
 *					idle state signalling.
 *					
 *					This call back is invoked when a wakeup from USB suspend 
 *					is detected.
 *
 * Note:            None
 *****************************************************************************/
void USBCBWakeFromSuspend(void)
{
	// If clock switching or other power savings measures were taken when
	// executing the USBCBSuspend() function, now would be a good time to
	// switch back to normal full power run mode conditions.  The host allows
	// a few milliseconds of wakeup time, after which the device must be 
	// fully back to normal, and capable of receiving and processing USB
	// packets.  In order to do this, the USB module must receive proper
	// clocking (IE: 48MHz clock must be available to SIE for full speed USB
	// operation).
}

/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB host sends out a SOF packet to full-speed
 *                  devices every 1 ms. This interrupt may be useful
 *                  for isochronous pipes. End designers should
 *                  implement callback routine as necessary.
 *
 * Note:            None
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
    // No need to clear UIRbits.SOFIF to 0 here.
    // Callback caller is already doing that.
}

/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The purpose of this callback is mainly for
 *                  debugging during development. Check UEIR to see
 *                  which error causes the interrupt.
 *
 * Note:            None
 *******************************************************************/
void USBCBErrorHandler(void)
{
    // No need to clear UEIR to 0 here.
    // Callback caller is already doing that.

	// Typically, user firmware does not need to do anything special
	// if a USB error occurs.  For example, if the host sends an OUT
	// packet to your device, but the packet gets corrupted (ex:
	// because of a bad connection, or the user unplugs the
	// USB cable during the transmission) this will typically set
	// one or more USB error interrupt flags.  Nothing specific
	// needs to be done however, since the SIE will automatically
	// send a "NAK" packet to the host.  In response to this, the
	// host will normally retry to send the packet again, and no
	// data loss occurs.  The system will typically recover
	// automatically, without the need for application firmware
	// intervention.
	
	// Nevertheless, this callback function is provided, such as
	// for debugging purposes.
}


/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        When SETUP packets arrive from the host, some
 * 					firmware must process the request and respond
 *					appropriately to fulfill the request.  Some of
 *					the SETUP packets will be for standard
 *					USB "chapter 9" (as in, fulfilling chapter 9 of
 *					the official USB specifications) requests, while
 *					others may be specific to the USB device class
 *					that is being implemented.  For example, a HID
 *					class device needs to be able to respond to
 *					"GET REPORT" type of requests.  This
 *					is not a standard USB chapter 9 request, and 
 *					therefore not handled by usb_device.c.  Instead
 *					this request should be handled by class specific 
 *					firmware, such as that contained in usb_function_hid.c.
 *
 * Note:            None
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
    USBCheckHIDRequest();
}//end


/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USBCBStdSetDscHandler() callback function is
 *					called when a SETUP, bRequest: SET_DESCRIPTOR request
 *					arrives.  Typically SET_DESCRIPTOR requests are
 *					not used in most applications, and it is
 *					optional to support this type of request.
 *
 * Note:            None
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
    // Must claim session ownership if supporting this request
}//end


/*******************************************************************
 * Function:        void USBCBInitEP(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called when the device becomes
 *                  initialized, which occurs after the host sends a
 * 					SET_CONFIGURATION (wValue not = 0) request.  This 
 *					callback function should initialize the endpoints 
 *					for the device's usage according to the current 
 *					configuration.
 *
 * Note:            None
 *******************************************************************/
void USBCBInitEP(void)
{
    //enable the HID endpoint
    USBEnableEndpoint(HID_EP,USB_IN_ENABLED|USB_OUT_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
    //Re-arm the OUT endpoint for the next packet
    USBOutHandle = HIDRxPacket(HID_EP,(BYTE*)&ReceivedDataBuffer,64);
}

/********************************************************************
 * Function:        void USBCBSendResume(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB specifications allow some types of USB
 * 					peripheral devices to wake up a host PC (such
 *					as if it is in a low power suspend to RAM state).
 *					This can be a very useful feature in some
 *					USB applications, such as an Infrared remote
 *					control	receiver.  If a user presses the "power"
 *					button on a remote control, it is nice that the
 *					IR receiver can detect this signalling, and then
 *					send a USB "command" to the PC to wake up.
 *					
 *					The USBCBSendResume() "callback" function is used
 *					to send this special USB signalling which wakes 
 *					up the PC.  This function may be called by
 *					application firmware to wake up the PC.  This
 *					function will only be able to wake up the host if
 *                  all of the below are true:
 *					
 *					1.  The USB driver used on the host PC supports
 *						the remote wakeup capability.
 *					2.  The USB configuration descriptor indicates
 *						the device is remote wakeup capable in the
 *						bmAttributes field.
 *					3.  The USB host PC is currently sleeping,
 *						and has previously sent your device a SET 
 *						FEATURE setup packet which "armed" the
 *						remote wakeup capability.   
 *
 *                  If the host has not armed the device to perform remote wakeup,
 *                  then this function will return without actually performing a
 *                  remote wakeup sequence.  This is the required behavior, 
 *                  as a USB device that has not been armed to perform remote 
 *                  wakeup must not drive remote wakeup signalling onto the bus;
 *                  doing so will cause USB compliance testing failure.
 *                  
 *					This callback should send a RESUME signal that
 *                  has the period of 1-15ms.
 *
 * Note:            This function does nothing and returns quickly, if the USB
 *                  bus and host are not in a suspended condition, or are 
 *                  otherwise not in a remote wakeup ready state.  Therefore, it
 *                  is safe to optionally call this function regularly, ex: 
 *                  anytime application stimulus occurs, as the function will
 *                  have no effect, until the bus really is in a state ready
 *                  to accept remote wakeup. 
 *
 *                  When this function executes, it may perform clock switching,
 *                  depending upon the application specific code in 
 *                  USBCBWakeFromSuspend().  This is needed, since the USB
 *                  bus will no longer be suspended by the time this function
 *                  returns.  Therefore, the USB module will need to be ready
 *                  to receive traffic from the host.
 *
 *                  The modifiable section in this routine may be changed
 *                  to meet the application needs. Current implementation
 *                  temporary blocks other functions from executing for a
 *                  period of ~3-15 ms depending on the core frequency.
 *
 *                  According to USB 2.0 specification section 7.1.7.7,
 *                  "The remote wakeup device must hold the resume signaling
 *                  for at least 1 ms but for no more than 15 ms."
 *                  The idea here is to use a delay counter loop, using a
 *                  common value that would work over a wide range of core
 *                  frequencies.
 *                  That value selected is 1800. See table below:
 *                  ==========================================================
 *                  Core Freq(MHz)      MIP         RESUME Signal Period (ms)
 *                  ==========================================================
 *                      48              12          1.05
 *                       4              1           12.6
 *                  ==========================================================
 *                  * These timing could be incorrect when using code
 *                    optimization or extended instruction mode,
 *                    or when having other interrupts enabled.
 *                    Make sure to verify using the MPLAB SIM's Stopwatch
 *                    and verify the actual signal on an oscilloscope.
 *******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;
    
    //First verify that the host has armed us to perform remote wakeup.
    //It does this by sending a SET_FEATURE request to enable remote wakeup,
    //usually just before the host goes to standby mode (note: it will only
    //send this SET_FEATURE request if the configuration descriptor declares
    //the device as remote wakeup capable, AND, if the feature is enabled
    //on the host (ex: on Windows based hosts, in the device manager 
    //properties page for the USB device, power management tab, the 
    //"Allow this device to bring the computer out of standby." checkbox 
    //should be checked).
    if(USBGetRemoteWakeupStatus() == TRUE) 
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();
            
            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0; 
            USBBusIsSuspended = FALSE;  //So we don't execute this code again, 
                                        //until a new suspend condition is detected.

            //Section 7.1.7.7 of the USB 2.0 specifications indicates a USB
            //device must continuously see 5ms+ of idle on the bus, before it sends
            //remote wakeup signalling.  One way to be certain that this parameter
            //gets met, is to add a 2ms+ blocking delay here (2ms plus at 
            //least 3ms from bus idle to USBIsBusSuspended() == TRUE, yeilds
            //5ms+ total delay since start of idle).
            delay_count = 3600U;        
            do
            {
                delay_count--;
            }while(delay_count);
            
            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}


/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *                        USB_EVENT event, void *pdata, WORD size)
 *
 * PreCondition:    None
 *
 * Input:           USB_EVENT event - the type of event
 *                  void *pdata - pointer to the event data
 *                  WORD size - size of the event data
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called from the USB stack to
 *                  notify a user application that a USB event
 *                  occured.  This callback is in interrupt context
 *                  when the USB_INTERRUPT option is selected.
 *
 * Note:            None
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_TRANSFER:
            //Add application specific callback task or callback function here if desired.
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:
            //Add application specific callback task or callback function here if desired.
            //The EVENT_TRANSFER_TERMINATED event occurs when the host performs a CLEAR
            //FEATURE (endpoint halt) request on an application endpoint which was 
            //previously armed (UOWN was = 1).  Here would be a good place to:
            //1.  Determine which endpoint the transaction that just got terminated was 
            //      on, by checking the handle value in the *pdata.
            //2.  Re-arm the endpoint if desired (typically would be the case for OUT 
            //      endpoints).
            break;
        default:
            break;
    }      
    return TRUE; 
}

/** EOF main.c *************************************************/
#endif
